︠35abd8cd-7b4a-4f96-820b-6d2b29ebae5c︠
def pol1(x, a):
    """
     Algoritmo pol1
    """
    n = a.shape[0]
    px = a[n-1]
    for j in range(n-2, -1, -1):
        px = px + a[j] * x^(n-j-1)
    return px
︡088c0331-9330-4258-9571-511ef8d78b0b︡︡
︠ab871486-42c9-4e0a-abc5-4439664a570c︠
def pol2(x, a):
    """ 
    Algoritmo pol2
    """
    n = a.shape[0]
    px = a[n-1]
    xp = 1
    for j in range(n-2, -1, -1):
        xp = xp*x
        px = px + a[j] * xp
    return px
︡464d9509-805b-456e-b727-db80e69317ab︡︡
︠24319455-8126-484b-92f4-e7af087ca24c︠
def horner(x, a):
    """
     Algoritmo di Horner
    """
    n = a.shape[0]
    px = a[0]
    for i in range(1, n):
        px = a[i] + px*x
    return px
︡65c6e1c8-c440-4695-a6bd-781ed7c0c916︡︡
︠88ff6e74-e461-460d-947b-5263e21f8557︠
import numpy as np
import matplotlib.pylab as plt
︡bea5a9c0-0f67-442c-a3d5-89437bc94131︡︡
︠ed3f4d18-0e12-4aea-818d-dd8e0e0e01ca︠
p = np.array([1,-6,15,-20,15,-6,1])
x = np.linspace(0.995,1.005,1000)
# rappresentazione compatta
y = (x-1)**6
︡4e03acad-4060-403d-baa9-f10009d4fae2︡︡
︠132a50c4-e1c0-42b4-ab6f-cde54d72be10︠
# Algoritmo di horner

yh = horner(x,p)
# Algoritmo  1

y1 = pol1(x,p)

# Algoritmo  2

y2 = pol2(x,p)
︡f25a0a79-126e-4f97-9a58-4cb8b0edc468︡︡
︠17653753-f48f-4fa3-9f1a-f9ea87b3042d︠
plt.plot(x,y,'-b',lw=2)

plt.plot(x,yh,'og')

plt.plot(x,y1,'*r')

plt.plot(x,y2,'vm')
plt.savefig('polfig.png')
︡f0a2a79f-3f5c-4671-87ba-4684a79b3a4b︡︡
